// eSecurty by Evi of au - Take Control!

// This library is lightly commented. Without basic knowledge of DM, you will not
// understand how this works.

#define POST(T) "<tt><font color=red>"+T+"</font></tt>" // Announcement style

var/list
	master_keys =list("Evi of au") // Make this your key. You have total control over the staff
                                   // * You may have more then one master key.
                                   // * The host will automatically be made a master key.

	staff_keys  =list()            // Staff list. Leave this blank, and add staff at runtime.

	controls    =list(/mob/staff/verb/reboot = "Reboot",       // Verb Path = "Verb Name",
                      /mob/staff/verb/kick   = "Kick",         // Put all staff verbs in this list
                      /mob/staff/verb/ban    = "Ban",          // with this format.
                      /mob/staff/verb/unban  = "Unban",
                      /mob/staff/verb/mute   = "Mute",
                      /mob/staff/verb/unmute = "Unmute",
                      /mob/staff/verb/lock   = "Lock",
                      /mob/staff/verb/unlock = "Unlock")

	banned      =list() // Do not allow the keys in this list to enter your game.
	muted       =list() // Do not allow the keys in this list to speak.
	locked      =list() // Do not allow the keys in this list to move.

world/New()
	..()
	loadSecurity() // Load the above variables when the world opens.

mob

	Move()
		if(src.key in locked) return   // This is for locking player movement.
		else ..()

	verb/Say(t as text)
		if(src.key in muted) return    // This is for muting player communications.
		else world<<"<b>[src.key]:</b> [t]"

	verb/Who()
		src<<"<b>Who's Online:</b>"
		for(var/mob/m in world)
			var/display="[m.name] ([m.key]) "
			if(m.key in master_keys)
				display+="\[<font color=red>Master</font>\] "
			if(m.key in staff_keys)
				if(m.key in master_keys) ..()
				else display+="\[<font color=green>Staff</font>\] "
			if(!m.client.address || m.client.address == "127.0.0.1" || m.client.address == world.address)
				display+="\[<font color=blue>Host</font>\] "
			src<<display

	Login()
		spawn()
			..()
			if(src.key in banned)
				src<<"You are banned!"
				spawn() del(src)
			src.hostCheck()                // Check for host status upon logging in.
			src.staffCheck()               // Check for staff/master status upon logging in.
			world<<"<b>[src] logged in.</b>"

	Logout()
		world<<"<b>[src] logged out.</b>"
		del(src)

mob
	proc

		hostCheck()
			if(!src.client.address || src.client.address == "127.0.0.1" || src.client.address == world.address)
				src<<POST("Welcome [src]! You are the host!")        // Add the host to the staff
				if(src.key in master_keys) ..()
				else
					staff_keys+=src.key
					staff_keys[src.key]=list()
					for(var/v in controls) staff_keys[src.key]+=v
					src.verbs+=typesof(/mob/master/verb)

		staffCheck()
			src.verbs-=typesof(/mob/staff/verb)
			if(src.key in master_keys)
				src.verbs+=typesof(/mob/master/verb)
				src.verbs+=typesof(/mob/staff/verb)
			if(src.key in staff_keys)
				for(var/v in staff_keys[src.key])
					src.verbs+=v

		getTargets()
			var/list/validTargets=list()
			for(var/mob/m in world)
				if(m.client)
					if(src == m) ..() // No targeting yourself
					else if(m.key in master_keys) ..() // No targeting master keys
					else if(src.key in master_keys && m.key in staff_keys) validTargets+=m // Masters can target staff
					else if(src.key in staff_keys && m.key in staff_keys) ..() // No Staff vs Staff
					else validTargets+=m // Everyone else is fair game.
			return validTargets

proc

	add_control(mob/m, key as text)
		var/list/addControls=typesof(/mob/staff/verb)
		var/list/currentControls=staff_keys[key]
		for(var/v in currentControls)
			if(v in addControls)
				addControls-=v
		var/list/controlNames=list()
		for(var/v in addControls)
			controlNames+=controls[v]
		var/t=input("What control would you like to add?","Add Control \[[key]\]")as null|anything in controlNames
		if(t)
			for(var/v in controls)
				if(controls[v] == t)
					staff_keys[key]+=v
					saveSecurity("staff")
			var/mob/theMob=key2mob(key)
			if(theMob) theMob.staffCheck()
			add_control(m, key)
		else return

	remove_control(mob/m, key as text)
		var/list/currentControls=staff_keys[key]
		var/list/controlNames=list()
		for(var/v in currentControls)
			controlNames+=controls[v]
		var/t=input("What control would you like to remove?","Remove Control \[[key]\]")as null|anything in controlNames
		if(t)
			for(var/v in controls)
				if(controls[v] == t)
					staff_keys[key]-=v
					saveSecurity("staff")
			var/mob/theMob=key2mob(key)
			if(theMob) theMob.staffCheck()
			remove_control(m, key)
		else return

	key2mob(theKey as text)
		for(var/mob/m in world)
			if(m.key == theKey)
				return m
		return null

	saveSecurity(save as text)
		switch(save)
			if("staff")
				var/savefile/staff=new("eSecurity/staff.sav")
				staff["staff_keys"]<<staff_keys
			if("banned")
				var/savefile/ban= new("eSecurity/banned.sav")
				ban["banned"]<<banned
			if("muted")
				var/savefile/mute= new("eSecurity/muted.sav")
				mute["muted"]<<muted
			if("locked")
				var/savefile/lock=new("eSecurity/locked.sav")
				lock["locked"]<<locked

	loadSecurity()
		var/savefile/staff=new("eSecurity/staff.sav")
		var/savefile/ban= new("eSecurity/banned.sav")
		var/savefile/mute= new("eSecurity/muted.sav")
		var/savefile/lock=new("eSecurity/locked.sav")

		staff["staff_keys"]>>staff_keys
		ban["banned"]>>banned
		mute["muted"]>>muted
		lock["locked"]>>locked

		if(!length(staff_keys)) staff_keys=list()

		for(var/v in master_keys)
			if(v in banned) banned-=v // Don't let youself get banned from your own game!
                                      // If a host is sneaky, they will try to edit the
                                      // savefile becuase the ban control wont allow a master
                                      // to be banned. This code ensures that it won't effect
                                      // you.

		if(!length(banned)) banned=list()
		if(!length(muted)) muted=list()
		if(!length(locked)) locked=list()

mob/master/verb

	Add_Staff(t as text) // Remember, add a staff's key, not thier ckey.
		set category="Staff"
		set name=" Add Staff"
		if(!t) return
		else if(t in master_keys) return
		else
			staff_keys+=t
			staff_keys[t]=list()
			saveSecurity("staff")
			add_control(src, t)
			world<<POST("[src] has added [t] to the staff list.")
			var/mob/theMob=key2mob(t)
			if(theMob) theMob.staffCheck()

	Edit_Staff()
		set category="Staff"
		set name=" Edit Staff"
		var/t=input("Which staff member will you edit?","Edit Staff")as null|anything in staff_keys
		if(t)
			var/command=input("What will you do?","Edit [t]")as null|anything in list("Add Controls","Remove Controls","View Controls","Remove Staff")
			switch(command)
				if("Add Controls")
					add_control(src, t)
				if("Remove Controls")
					remove_control(src, t)
				if("View Controls")
					var/list/l=staff_keys[t]
					if(l.len)
						src<<"<b>[t]'s Controls:</b>"
						for(var/v in staff_keys[t])
							src<<controls[v]
					else
						src<<"<b>[t] current has no controls.</b>"
				if("Remove Staff")
					staff_keys.Remove(t)
					saveSecurity("staff")
					world<<POST("[src] has removed [t] from the staff list.")
					var/mob/theMob=key2mob(t)
					if(theMob) theMob.staffCheck()



mob/staff/verb

	reboot()
		set category="Staff"
		set name="Reboot"
		var/confirm=input("Are you sure you want to Reboot?","Confirm Reboot")as null|anything in list("Yes","No")
		if(confirm=="Yes")
			world<<POST("[src] has Rebooted the world!")
			world.Reboot()

	kick()
		set category="Staff"
		set name="Kick"
		var/list/players=src.getTargets()
		if(players.len)
			var/mob/m=input("Who would you like to kick?","Kick Player")as null|mob in players
			if(m)
				var/confirm=input("Are you sure you want to kick [m] ([m.key])?","Confirm Kick")as null|anything in list("Yes","No")
				if(confirm=="Yes")
					world<<POST("[m] ([m.key]) has been kicked by [src]!")
					del(m)
		else
			src<<POST("No valid targets.")

	ban()
		set category="Staff"
		set name="Ban"
		var/list/players=src.getTargets()
		if(players.len)
			var/mob/m=input("Who would you like to ban?","Ban Player")as null|mob in players
			if(m)
				var/confirm=input("Are you sure you want to ban [m] ([m.key])?","Confirm Ban")as null|anything in list("Yes","No")
				if(confirm=="Yes")
					if(src.key in banned) src<<POST("[m] ([m.key]) is allready banned!")
					else
						world<<POST("[m] ([m.key]) has been banned by [src]!")
						banned+=m.key
						saveSecurity("banned")
						del(m)
		else
			src<<POST("No valid targets.")

	unban()
		set category="Staff"
		set name="Unban"
		var/theKey=input("Who do you wish to Unban?","Unban")as null|anything in banned
		if(theKey)
			var/confirm=input("Are you sure you want to Unban [theKey]?","Confirm Unban")as null|anything in list("Yes","No")
			if(confirm=="Yes")
				banned-=theKey
				world<<POST("[theKey] has been Unbanned by [src]!")
				saveSecurity("banned")

	mute()
		set category="Staff"
		set name="Mute"
		var/list/players=src.getTargets()
		if(players.len)
			var/mob/m=input("Who would you like to mute?","Mute Player")as null|mob in players
			if(m)
				var/confirm=input("Are you sure you want to mute [m] ([m.key])?","Confirm Mute")as null|anything in list("Yes","No")
				if(confirm=="Yes")
					if(src.key in muted) src<<POST("[m] ([m.key]) is allready muted!")
					else
						world<<POST("[m] ([m.key]) has been muted by [src]!")
						muted+=m.key
						saveSecurity("muted")
		else
			src<<POST("No valid targets.")

	unmute()
		set category="Staff"
		set name="Unmute"
		var/theKey=input("Who do you wish to Unmute?","Unmute")as null|anything in muted
		if(theKey)
			var/confirm=input("Are you sure you want to Unmute [theKey]?","Confirm Unmute")as null|anything in list("Yes","No")
			if(confirm=="Yes")
				muted-=theKey
				world<<POST("[theKey] has been Unmuted by [src]!")
				saveSecurity("muted")

	lock()
		set category="Staff"
		set name="Lock"
		var/list/players=src.getTargets()
		if(players.len)
			var/mob/m=input("Who would you like to lock?","Lock Player")as null|mob in players
			if(m)
				var/confirm=input("Are you sure you want to lock [m] ([m.key])?","Confirm Lock")as null|anything in list("Yes","No")
				if(confirm=="Yes")
					if(src.key in locked) src<<POST("[m] ([m.key]) is allready locked!")
					else
						world<<POST("[m] ([m.key]) has been locked by [src]!")
						locked+=m.key
						saveSecurity("locked")
		else
			src<<POST("No valid targets.")

	unlock()
		set category="Staff"
		set name="Unlock"
		var/theKey=input("Who do you wish to Unlock?","Unlock")as null|anything in locked
		if(theKey)
			var/confirm=input("Are you sure you want to Unlock [theKey]?","Confirm Unlock")as null|anything in list("Yes","No")
			if(confirm=="Yes")
				locked-=theKey
				world<<POST("[theKey] has been Unlocked by [src]!")
				saveSecurity("locked")